clearvars; clc;

datoteka_tocke = "..\podatki\tocke_relativni_vektorji.csv";

tocke = readtable(datoteka_tocke, Delimiter=';', TextType='string');
% imena stolpcev so privzeta iz glave datoteke:
% stolpci: id | lat | lon | NUVEL_1_REL

model = "NUVEL_1_REL";

datoteka_rezultati = strcat('..\rezultati\tocke-', model, '.txt');
fout = fopen(datoteka_rezultati, 'w');
    
fprintf(fout, "        [°]     [°]   [m/leto]  [m/leto]  [m/leto]  [m/leto]     [°]\n");
fprintf(fout, " id     lat     lon      ve        vn        vu        v2d        azi        pl\n");

for i = 1 : size(tocke, 1)
    plosca = tocke.NUVEL_1_REL(i);
    
    % Napiši funkcijo fila2xyz, ki kot vhodne argumente sprejme geografsko širino in dolžino (fi, la)
    % ter polmer Zemlje R in vrne 3D kartezične koordinate (X, Y, Z).
    % Pazi na enote.
    % PROTOTIP FUNKCIJE: function [X, Y, Z] = fila2xyz(fi_deg, la_deg, R) 
    [X, Y, Z] = fila2xyz(tocke.lat(i), tocke.lon(i));
    
    % Uporabi že napisano funkcijo get_Euler_vector (uporaba je razložena v funkciji).
    [W, FI, LA] = get_Euler_vector(plosca, model);


    % Napiši funkcijo ev2rv, ki kot vhodne parametre sprejme parametre Eulerjevega vektorja (rezultat
    % funkcije get_Euler_vector) in ga pretvori v rotacijski vektor (enačbe (5) v navodilh).
    % PROTOTIP FUNKCIJE: function [wx, wy, wz] = ev2rv(W, FI_deg, LA_deg)
    [wx, wy, wz] = ev2rv(W, FI, LA);
    

    % Napiši funkcijo get_velocity_vector, ki kot vhodne parametre sprejme 3D kartezične koordinate
    % in komponente rotacijskega vektorja, vrne pa komponente absolutnega vektorja hitrosti v 
    % ECEF koordinatnem sistemu (enačba (3) v navodilh).
    % PROTOTIP FUNKCIJE: function [vx, vy, vz] = get_velocity_vector(X, Y, Z, wx, wy, wz)
    [vx, vy, vz] = get_velocity_vector(X, Y, Z, wx, wy, wz);


    % Napiši funkcijo vxyz2vneu, ki kot vhodne parametre sprejme komponente absolutnega vektorja
    % hitrosti v ECEF koordinatnem sistemu in vrne komponente absolutnega vektorja hitrosti
    % v LG koordinatnem sistemu (enačbe (6) v navodilh).
    % PROTOTIP FUNKCIJE: function [vn, ve, vu] = vxyz2vneu(vx, vy, vz, fi_deg, la_deg)
    [vn, ve, vu] = vxyz2vneu(vx, vy, vz, tocke.lat(i), tocke.lon(i));

    v2d = 0;
    azi = 0;    % pazi na kvadrante
    
    fprintf(fout, "%s %6.1f  %6.1f  %8.4f  %8.4f  %8.4f  %8.4f  %10.4f  %s\n", ...
        tocke.id(i), tocke.lat(i), tocke.lon(i), ve, vn, vu, v2d, azi, plosca);
end

fclose(fout);
